"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MySqlQuery = void 0;
class MySqlQuery {
    constructor(qString, connection, options) {
        this.parameters = {};
        this.qString = qString;
        this.dbconn = connection;
        if (options) {
            if (options.parameters)
                this.parameters = options.parameters;
        }
    }
    query() {
        return new Promise((resolve, reject) => {
            this.dbconn.query(this.qString, this.parameters, (err, results, fields) => {
                if (err)
                    return reject(err);
                return resolve({ results: results, fields });
            });
        });
    }
    executeNonQuery() {
        return new Promise((resolve, reject) => {
            this.query().then(q => {
                return resolve(q.results);
            }).catch(err => {
                return reject(err);
            });
        });
    }
    executeQuery() {
        return this.query();
    }
    executeScalar() {
        return new Promise((resolve, reject) => {
            this.query().then(q => {
                const result = Object.assign({}, q.results[0]);
                if (!result) {
                    throw new Error('Unable to determine a scalar result to output');
                }
                else {
                    return resolve(result[Object.keys(result)[0]]);
                }
            }).catch(err => reject(err));
        });
    }
}
exports.MySqlQuery = MySqlQuery;
//# sourceMappingURL=index.js.map